#include "crossroads.h"

int fork_tcp_servicer (int to_backend) {
    int pid, i;

    if ( (pid = fork()) < 0 )
	/* Fork failure */
	error ("Service %s: failed to fork: %s",
	       activeservice->name, strerror(errno));
    else if (pid) {
	/* Parent branch */
	msg ("Service %s: communications will be handled by pid %d",
	     activeservice->name, pid);
	return (pid);
    } else {
	/* Child branch: here we will serve the socket pair.
	 * We want to catch interrupts, but not die. */
	for (i = 0; relevant_sigs[i]; i++)
	    signal (relevant_sigs[i], interrupt);
	
	/* Forked for the second time... */
	program_stage = stage_serving;
	
	if (to_backend > 0)
	    set_program_title ("Service %s: serving, back end is %s",
			       activeservice->name,
			       activeservice->backend [current_backend].name);
	else	
	    set_program_title ("Service %s: serving",
			       activeservice->name);
	return (0);
    }

    /* To satisfy the prototype... */
    return (0);
}
