#include "crossroads.h"

// #define DEBUG

#ifdef DEBUG
static void debughdr (HttpHeader *h) {
    int i;
    msg ("http header read: %d headers so far", h->nheader);
    for (i = 0; i < h->nheader; i++)
	msg ("http header read: header[%d] '%s'",
	     i, h->header[i]);
}

#define SHOWHEADERS(h)  debughdr((h))
#else
#define SHOWHEADERS(h)
#endif

void http_header_read (HttpHeader *h, int sock, CopyDirection dir) {
    unsigned char *cp;
    int last_is_nl = 0, at_start = 1;

    msg ("Service %s: reading HTTP headers from %s",
	 activeservice->name,
	 dir == dir_client_to_server ? "client" : "server");
    while (1) {
	cp = net_bufread (sock, 1, 0, dir == dir_client_to_server);
	// msg ("http header read: got char %d (%c)", *cp, *cp);
	// SHOWHEADERS(h);
	if (*cp == '\r')
	    continue;
	if (*cp == '\n') {
	    if (last_is_nl && h->nheader)
		break;
	    last_is_nl++;
	    continue;
	}
	if (at_start || last_is_nl) {
	    h->header = xrealloc (h->header, (h->nheader + 1) * sizeof(char*));
	    h->header[h->nheader] = 0;
	    h->nheader++;
	    at_start = 0;
	}
	h->header[h->nheader - 1] = xstrcatch (h->header[h->nheader - 1], *cp);
	last_is_nl = 0;
    }

    SHOWHEADERS(h);
}
