#include "crossroads.h"

/* Signal handler */
void interrupt (int sig) {
    interrupted++;
    
    switch (program_stage) {
    case stage_waiting:
	warning ("Service %s: listener caught signal %d, "
		 "closing socket %d and exiting",
		 activeservice->name, sig, listen_sock);
	if (shutdown (listen_sock, SHUT_RDWR))
	    error ("Service %s: can't shut down server-side socket %d: %s",
		     activeservice->name, listen_sock, strerror(errno));
	if (close (listen_sock))
	    error ("Service %s: can't close socket %d: %s",
		   activeservice->name, listen_sock, strerror(errno));
	exit (0);
    case stage_serving:
	warning ("Service %s: servicer caught signal %d, "
		 "will exit after servicing my connection",
		 activeservice->name, sig);
	break;
    case stage_retrying:
	warning ("Service %s: wakeup handler caught signal %d, "
		 "stopping wake ups and exiting",
		 activeservice->name, sig);
	exit (0);
    default:
	msg ("Caught signal %d in program stage %s, exiting", sig,
	     stage_to_string (program_stage));
	exit (0);
    }
}
