#include "crossroads.h"

unsigned char *net_bufread (int sock, unsigned max, unsigned *nread,
		      int is_client) {
    unsigned char *buf;
    unsigned *bufpos, *bufmax, rest;
    unsigned char *ret;

    /* Make sure we have the buffers. */
    if (!clbuf) {
	clbuf = xmalloc (TCP_BUFSZ);
	srbuf = xmalloc (TCP_BUFSZ);
	clbufmax = srbufmax = 0;
	msg ("Service %s: Allocated client and server buffers",
	     activeservice->name);
    }

    if (is_client) {
	buf = clbuf;
	bufpos = &clbufpos;
	bufmax = &clbufmax;
    } else {
	buf = srbuf;
	bufpos = &srbufpos;
	bufmax = &srbufmax;
    }

    /* If buffer is empty, do an actual read */
    if (! *bufmax) {
	*bufmax = net_read (sock, TCP_BUFSZ, buf, is_client);
	msg ("Service %s: Got %u bytes from %s",
	     activeservice->name, *bufmax, is_client ? "client" : "server");
	*bufpos = 0;
    }

    /* Got buffer contents. How much do we return? */
    rest = *bufmax - *bufpos;
    
    if (rest > max) {
	/* Caller wants less than what we have in cache. */
	if (nread)
	    *nread = max;
	ret = buf + *bufpos;
	*bufpos += max;
    } else {
	/* Caller wants more than what we have in cache.
	 * We'll return what we got. */
	if (nread)
	    *nread = rest;
	ret = buf + *bufpos;
	*bufmax = 0;
    }
    
    return (ret);
}
