#include "crossroads.h"

void set_program_title (char const *fmt, ...) {
#   if SET_PROC_TITLE_BY_ARGV == 1
    
    static int orglen;
    char *title, *name = "crossroads";
    int i, j, k;
    va_list args;

    /* Make the title */
    va_start (args, fmt);
    title = str_vprintf (fmt, args);
    va_end (args);

    /* Reset old argv, count max length */
    if (! orglen)
	for (i = 0; i < org_argc; i++)
	    orglen += (strlen(org_argv[i]) + 1);

    /* Paste in our program name first */
    for (i = 0; i <= strlen(name) && i < orglen; i++)
	org_argv[0][i] = name[i];

    /* Paste in the new title */
    for (j = 0; j < strlen(title) && i + j < orglen; j++)
	org_argv[0][i + j] = title[j];

    /* Reset remainder of old cmd line */
    for (k = i + j; k < orglen; k++)
	org_argv[0][k] = 0;

    /* Free up */
    free (title);
    
#   endif  /* SET_PROC_TITLE_BY_ARGV */
}
